<template>
  <div class="main-contain">
    <div class="position">
      <bread-crumb v-if="this.$route.query.type == 1" :crumbs='crumbs'></bread-crumb>
      <bread-crumb v-if="this.$route.query.type == 2" :crumbs='crumbs2'></bread-crumb>
      <div style="float:right;">
        <el-button size="small"  @click="back()" class="filter-item"   >取 消</el-button>
        <el-button size="small"  type="primary" @click="submit()" class="filter-item" >保 存</el-button>
      </div>
    </div>
    <div class="app-container">
    
      <drugs-stock-dialog
        ref="dialog" :propForm="propForm"
        :visibility="isVisibility"
        v-on:dialog-comfirm="comfirm"
        v-on:dialog-cancle="cancle"
      >
      </drugs-stock-dialog>
      <div class="cell clearfix">
        <label class="title"><span class="name"><span style="color:red">*</span>仓库</span> :</label>
          <el-select size="small" v-model="storehouse_id" filterable placeholder="请选择仓库" style="width:200px" :disabled="true">
            <el-option
              v-for="(option, index) in houseList"
              :key="index"
              :label="option.storehouse_name"
              :value="option.id">
            </el-option>
          </el-select>
        <label class="title"><span class="name">退库时间</span> : </label>
        <el-date-picker size="small" v-model="return_time" prefix-icon="el-icon-date" :editable="false" style="width: 196px;"
                        type="date" placeholder="选择日期时间" align="right" format="yyyy-MM-dd"
                        value-format="yyyy-MM-dd"></el-date-picker>
      </div>

      <el-form :rules="tableRules" :model="recordInfo" ref="tableForm">
        <el-table :data="recordInfo.recordData" :class="signAndWeighBoxPatients" style="width: 100%" border  max-height="450" :header-cell-style="{ backgroundColor: 'rgb(245, 247, 250)'}"
        >
             <el-table-column align="center" width="200">
            <template slot="header" slot-scope="scope">
              <span>药品名称<span style="color: red">*</span></span>
            </template>

            <template slot-scope="scope">
              <el-form-item style="padding-top: 20px">
                  <el-autocomplete
                    class="checkSearch"
                    popper-class="my-autocomplete"
                    v-model="scope.row.drug_name"
                    :fetch-suggestions="querySearchAsync"
                    :trigger-on-focus="true"
                    placeholder="请输入药品名称"
                    @select="handleSelect"
                    @input="changeDrugName(scope.$index)"
                    style="width:160px;"
                  >
                    <i class="el-icon-search el-input__icon" slot="suffix"></i>
                  <template slot-scope="{ item }">
                    <div class="name">{{ item.drug_name + item.dose + item.dose_unit + "*" +item.min_number + item.min_unit +"/" + item.max_unit + "  "+item.manufacturer}}</div>
                  </template>
                 </el-autocomplete>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column align="center" width="140">
            <template slot="header" slot-scope="scope">
              <span>规格&单位</span>
            </template>
            <template slot-scope="scope">
              <el-form-item style="padding-top: 20px">
                <el-input
                  :disabled="true"
                  placeholder="请输入规格&单位"
                  v-model="scope.row.name"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>退库数量<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.count'"
                :rules="tableRules.count"
                style="padding-top: 17px"
              >
              <div style="display:flex;">
                <el-input
                 oninput="value=value.replace(/\D|^0/g,'')"
                  style="width:100px"
                  placeholder="请输入退库数量"
                  type="number"
                  v-model="scope.row.count"
                ></el-input>
                 <el-select v-model="scope.row.max_unit" filterable placeholder="请选择单位" style="width:80px">
                    <el-option
                      v-for="(option, index) in unitList"
                      :key="index"
                      :label="option.name"
                      :value="option.name">
                    </el-option>
                  </el-select>
                </div>
              </el-form-item>
            </template>
          </el-table-column>

         <el-table-column align="center" width="150">
            <template slot="header" slot-scope="scope">
              <span>退库单价<span style="color: red">*</span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.price'"
                :rules="tableRules.price"
                style="padding-top: 17px"
              >
                <el-input
                  placeholder="请输入单价"
                  type="number"
                  v-model="scope.row.price"
                ></el-input>
              </el-form-item>
            </template>
          </el-table-column>

          <el-table-column label="总价" align="center" width="150">
            <template slot-scope="scope">
              {{ calculate(scope.row.price * scope.row.count) }}
            </template>
          </el-table-column>

          <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>批次<span style="color: red"></span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.return_count'"
                style="padding-top: 17px"
              >
               <el-select v-model="scope.row.batch_number" filterable placeholder="请选择" :disabled="canCelShow">
                  <el-option
                    v-for="(item,index) in numberList"
                    :key="index"
                    :label="item.batch_number"
                    :value="item.id">
                  </el-option>
              </el-select>
              </el-form-item>
            </template>
          </el-table-column>

           <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>品名/注册证号(备案凭证号)<span style="color: red"></span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.register_account'"
                style="padding-top: 17px"
              >
              <el-input v-model="scope.row.register_account"></el-input>
              </el-form-item>
            </template>
          </el-table-column>
           <el-table-column label="生产厂家" width="160" align="center">
            <template slot-scope="scope">
               <el-select v-model="scope.row.manufacturer" filterable placeholder="请选择厂商">
                <el-option
                  v-for="(option, index) in manufacturerList"
                  :key="index"
                  :label="option.manufacturer_name"
                  :value="option.manufacturer_name">
                </el-option>
               </el-select>
            </template>
          </el-table-column>
 

          <el-table-column label="生产日期" width="180" align="center">
            <template slot-scope="scope">
              <el-date-picker
                prefix-icon="el-icon-date"
                style="width: 145px"
                v-model="scope.row.product_date"
                type="date"
                placeholder="选择日期时间"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
              ></el-date-picker>
            </template>
          </el-table-column>
          <el-table-column label="有效日期" width="180" align="center">
            <template slot-scope="scope">
              <el-date-picker
                prefix-icon="el-icon-date"
                style="width: 145px"
                v-model="scope.row.expiry_date"
                type="date"
                placeholder="选择日期时间"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
              ></el-date-picker>
            </template>
          </el-table-column>


        <el-table-column label="经销商" width="160" align="center">
            <template slot-scope="scope">
                <el-select v-model="scope.row.dealer" filterable placeholder="请选择厂商">
                <el-option
                  v-for="(option, index) in dealerList"
                  :key="index"
                  :label="option.dealer_name"
                  :value="option.dealer_name">
                </el-option>
                </el-select>
            </template>
          </el-table-column>
          <el-table-column width="200" align="center">
            <template slot="header" slot-scope="scope">
              <span>退库原因<span style="color: red"></span></span>
            </template>
            <template slot-scope="scope">
              <el-form-item
                :prop="'recordData.' + scope.$index + '.remark'"
                style="padding-top: 17px"
              >
              <el-input v-model="scope.row.remark"></el-input>
              </el-form-item>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" width="200" fixed="right">
            <template slot-scope="scope">
              <el-tooltip
                class="item"
                effect="dark"
                content="新增"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="primary"
                  icon="el-icon-circle-plus-outline"
                  @click="handleEdit(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
              <el-tooltip
                class="item"
                effect="dark"
                content="删除"
                placement="top"
              >
                <el-button
                  size="mini"
                  type="danger"
                  icon="el-icon-delete"
                  @click="handleDelete(scope.$index, scope.row)"
                >
                </el-button>
              </el-tooltip>
            </template>
          </el-table-column>

        </el-table>
      </el-form>

    </div>
  </div>

</template>

<script>
  import { uParseTime } from '@/utils/tools'

  import { deleteDrugCancelStockInfo, editDrugCancelStockInfo, getDrugCancelStockInfo,GetAllDrugInfoByID,GetAllConfig,getDrugBatchNumber  } from '@/api/drug/drug_stock'
  import BreadCrumb from '../../components/bread-crumb'
  import DrugsStockDialog from './drugsStockDialog/index'
  import {postSearchDrugList} from "@/api/data"
  export default {
    components: { DrugsStockDialog, BreadCrumb },
    name: 'cancelStockOrderEdit',

    data() {
      return {
        crumbs: [
          { path: false, name: '库存管理' },
          { path: false, name: '药品退库单' },
          { path: false, name: '编辑退库单' }
        ],

        crumbs2: [
          { path: false, name: '库存管理' },
          { path: false, name: '其他退库单' },
          { path: false, name: '编辑退库单' }
        ],


        signAndWeighBoxPatients: 'sign-and-weigh-box-patients',
        warehousing_time: '',
        adminUserOptions: null,
        currentIndex: 0,
        return_time: '',
        recordInfo: {
          recordData: [],
          stock_in_code: '',
          current_index: ''

        },
        tableRules: {
          count: [
            { required: true, message: '数量不能为空', trigger: 'blur' }
          ]

        },
        ruleForm: {
          manufacturer: [
            { required: true, message: '请选择厂商', trigger: 'change' }
          ]

        },

        // prop
        isVisibility: false,
        propForm: {
          goods: [],
          goodType: [],
          goodInfo: [],
          goodUnit: [],
          manufacturer: 0,
          dealer: 0
        },

        form: {
          manufacturer: '',
          dealer: ''
        },
        warehouseOutInfoList:[],
        cancelStock: {},
        manufacturer: [],
        dealer: [],
        goodType: [],
        goodInfo:[],
        manufacturerList:[],
        dealerList:[],
        numberList:[],
        unitList:[],
        canCelShow:true,
        storehouse_id:"",
        houseList:[],
      }
    },
    methods: {
      comfirm: function(val) {
        this.$refs.dialog.hide()

        if (val.selectedGoodInfo.length > 0) {
          for (let i = val.selectedGoodInfo.length - 1; ; i--) {
            if (i == 0) {

              this.recordInfo.recordData[this.currentIndex].drug_id = val.selectedGoodInfo[i].id
              this.recordInfo.recordData[this.currentIndex].price = val.selectedGoodInfo[i].last_price.toString()
              this.recordInfo.recordData[this.currentIndex].retail_price = val.selectedGoodInfo[i].retail_price.toString()

            } else {
              const tempForm = {}
              tempForm['id'] = 0
              tempForm['drug_id'] = val.selectedGoodInfo[i].id
              tempForm['count'] = ''
              tempForm['price'] = val.selectedGoodInfo[i].last_price.toString()
              tempForm['retail_price'] =  val.selectedGoodInfo[i].retail_price.toString()
              this.recordInfo.recordData.splice(this.currentIndex + 1, 0, tempForm)
            }
          }
        }

        this.currentIndex = -1
      }, cancle: function() {
        this.$refs.dialog.hide()
      },
      calculate: function(val) {
        if (val == 0 || val == "NaN") {
          return ''
        }
        return Math.round(parseFloat(val) * 100) / 100
      },
      GetConfigInfo: function() {
        const loading = this.$loading({
          lock: true,
          text: 'Loading',
          spinner: 'el-icon-loading',
          background: 'rgba(0, 0, 0, 0.7)'
        })

        GetAllConfig().then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
          } else {
            this.manufacturer = response.data.data.manufacturer;
            this.dealer = response.data.data.dealer;
            for(let i = 0; i<  response.data.data.drugs.length;i++){
              this.goodType.push(response.data.data.drugs[i])
              if(response.data.data.drugs[i].drug_specs != null) {
                for (let b = 0; b < response.data.data.drugs[i].drug_specs.length; b++) {
                  this.goodInfo.push(response.data.data.drugs[i].drug_specs[b])
                }
              }
            }
            this.manufacturer.splice(0, 0, { id: 0, manufacturer_name: "全部" });
            this.dealer.splice(0, 0, { id: 0, dealer_name: "全部" });
          }
          loading.close()
        })

      },

      typeName: function(drug_id) {
        let name = "";
        for (let i = 0; i < this.goodInfo.length; i++) {
          if (this.goodInfo[i].id == drug_id) {
            name = this.goodInfo[i].drug_name;

          }
        }
        return name;
      },  specificationName: function(drug_id) {

        let name = "";
        for (let i = 0; i < this.goodInfo.length; i++) {
          if (this.goodInfo[i].id == drug_id) {
            name = this.goodInfo[i].drug_spec;
          }
        }
        return name;
      }, 
      handleEdit: function(index, row) {
        this.canCelShow = false
        const tempObj = {}
        tempObj['id'] = 0
        tempObj["return_count"] = "";
        tempObj["price"] = 0;
        tempObj["retail_price"] = "";
        tempObj["register_account"] = ""
        tempObj["dealer"] = ""
        tempObj["manufacturer"] =""
        tempObj["remark"] = ""
        tempObj["product_date"] = ""
        tempObj["expiry_date"] = ""
        tempObj["batch_number"] = ""
        tempObj["batch_number_id"] = 0
         tempObj["count"] = 0
        this.recordInfo.recordData.push(tempObj)
      }, handleDelete: function(index, row) {
        if (row.id == 0) {
          this.recordInfo.recordData.splice(index, 1)
        } else {
          const params = {
            id: row.id
          }
          this.$confirm('确认删除该退库商品信息记录?', '删除退库商品信息记录', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }).then(() => {
            deleteDrugCancelStockInfo(params).then(response => {
              if (response.data.state == 0) {
                this.$message.error(response.data.msg)
                return false
              } else {
                this.$message.success('删除成功')
                this.recordInfo.recordData.splice(index, 1)
              }
            })
          }).catch(() => {
          })
        }
      }, getTime(val, temp) {
        if (val != 0) {
          return uParseTime(val, temp)
        } else {
          return ''
        }
      },
      showDialog(index, row) {
        const loading = this.$loading({
          lock: true,
          text: 'Loading',
          spinner: 'el-icon-loading',
          background: 'rgba(0, 0, 0, 0.7)'
        })
        this.currentIndex = index
        this.isVisibility = true
        const params = {
          manufacturer_id: this.form.manufacturer,
          dealer_id: this.form.dealer
        }
        GetAllDrugInfoByID(params).then(response => {
            if (response.data.state == 0) {
              this.$message.error(response.data.msg)
              return false
              loading.close()

            } else {
              loading.close()
              if (response.data.data.drugs.length <= 0) {
                this.$message.error("该厂商或经销商没有药品信息");
                return;
              }
              this.$refs.dialog.show();
              for (let i = 0; i < response.data.data.drugs.length; i++) {
                this.propForm.goods.push(
                  response.data.data.drugs[i]
                );
              }
              const obj = {};
              this.propForm.goods = this.propForm.goods.reduce(
                (cur, next) => {
                  obj[next.id] ? "" : (obj[next.id] = true && cur.push(next));
                  return cur;
                },
                []
              ); // 设置cur默认类型为数组，并且初始值为空的数组
            }
          for (let i = 0; i < this.propForm.goods.length; i++) {
            for (let a = 0; a < this.propForm.goods[i].drug_specs.length; a++) {
              var respObj = this.propForm.goods[i].drug_specs[a];
              respObj["isSelected"] = false;
            }
          }
          loading.close();
          }
        )
      },

      back() {
        this.$router.go(-1)
      },
     submit() {
        this.$refs['tableForm'].validate((valid) => {
          if (valid) {
            const array = this.recordInfo.recordData
            for (let i = 0; i < array.length; i++) {
              if (array[i].drug_id == 0) {
                this.$message.error('药品名称或者药品规格名称不能为空')
                return
              }
            }

            for(let i=0;i<this.recordInfo.recordData.length;i++){
              for(let j=0;j<this.numberList.length;j++){
                 if(this.recordInfo.recordData[i].batch_number == this.numberList[j].id){
                   this.recordInfo.recordData[i].batch_number = this.numberList[j].batch_number
                   this.recordInfo.recordData[i].batch_number_id = this.numberList[j].id
                 }
              }
              this.recordInfo.recordData[i].price = this.recordInfo.recordData[i].price.toString()
            }

            const params = {
              'cancelStock': this.recordInfo.recordData
            }
           
            
            editDrugCancelStockInfo(params, this.return_time, this.$route.query.id, this.$route.query.type,this.form.manufacturer,this.form.dealer,this.storehouse_id).then(response => {
              if (response.data.state == 0) {
                this.$message.error(response.data.msg)
                return false
              } else {
                if (response.data.data.msg == 1){
                   this.$message.success('退库成功')
                   this.$router.back(-1)
                }
                if(response.data.data.msg == 2){
                   this.$message.error("该批次退库数量大于入库数量,请更改批次")
                }
                if(response.data.data.msg == 4){
                  this.$message.error("该批次退库数量大于出库数量,请更改批次")
                }
              
              }
            })
          } else {
            return false
          }
        })
      },
       GetOrderDetail: function(order_id) {
        const params = {
          'id': order_id
        }

        getDrugCancelStockInfo(params).then(response => {
          if (response.data.state == 0) {
            this.$message.error(response.data.msg)
            return false
          } else {
           
            for (let i = 0; i < response.data.data.list.length; i++) {
              response.data.data.list[i].count = response.data.data.list[i].count.toString()
              response.data.data.list[i].price = response.data.data.list[i].price.toString()
              response.data.data.list[i].retail_price = response.data.data.list[i].retail_price.toString()
              response.data.data.list[i].product_date = this.getTime(response.data.data.list[i].product_date,'{y}-{m}-{d}')
              response.data.data.list[i].expiry_date = this.getTime(response.data.data.list[i].expiry_date,'{y}-{m}-{d}')
              response.data.data.list[i].drug_name = response.data.data.list[i].drug.drug_name
              response.data.data.list[i].name =  response.data.data.list[i].drug.dose +''+response.data.data.list[i].drug.dose_unit+"*"+response.data.data.list[i].drug.min_number+response.data.data.list[i].drug.min_unit+"/"+response.data.data.list[i].drug.max_unit

              this.recordInfo.recordData.push(response.data.data.list[i])
            }
            this.cancelStock = response.data.data.info
           
            this.storehouse_id = response.data.data.info.storehouse_id
            this.return_time = this.getTime(this.cancelStock.return_time, '{y}-{m}-{d}')
            this.form.manufacturer = this.cancelStock.manufacturer
            this.form.dealer = this.cancelStock.dealer
            this.houseList = response.data.data.houselist
          }
          if (this.recordInfo.recordData.length == 0) {
            const tempObj = {}
            tempObj['id'] = 0
            tempObj['drug_id'] = 0
            tempObj['count'] = ''
            tempObj['price'] = ''
            tempObj['retail_price'] = ''
            this.recordInfo.recordData.push(tempObj)
          }
        })
      },changeManufacturer(val) {
        this.propForm.manufacturer = val
      },changeDealer(val){
        this.propForm.dealer = val
      },
       querySearchAsync(keyword, cb) {
        let key = '';
        if (keyword != undefined) {
          key = keyword
        }
        let searchArray = [];
        postSearchDrugList(key,this.storehouse_id).then(response => {
          if (response.data.state == 1) {
            searchArray = response.data.data.list;
            
             var list = response.data.data.list
      

             this.drugList = list
             var manufacturerList = response.data.data.manufacturerList
             this.manufacturerList = manufacturerList
             var dealerList = response.data.data.dealerList
             this.dealerList = dealerList
             for(let i=0;i<this.drugList.length;i++){
             
                for(let j=0;j<this.manufacturerList.length;j++){
                  if(this.drugList[i].manufacturer == this.manufacturerList[j].id){
                     this.drugList[i].manufacturer = this.manufacturerList[j].manufacturer_name
                  }
                }
               

                for(let z=0;z<dealerList.length;z++){
                  if(this.drugList[i].dealer == this.dealerList[z].id){
                      this.drugList[i].dealer = this.dealerList[z].dealer_name
                  }
               
                }
             }
             cb(this.drugList)
          } else {
            cb([])
          }
        })
      },
      changeDrugName(val){
        this.currentIndex = val
      },
      handleSelect(val){
         var arr = []
         for(let i=0;i<this.recordInfo.recordData.length;i++){
            arr.push(this.recordInfo.recordData[i].drug_id)
         }
         var str = arr.join(",")
       
         if(str.indexOf(val.id)!=-1){
            this.$message.error("该药品已存在列表中")
            return
         }
         this.getDrugBatchNumber(val.id)

         for(let i=0;i<this.recordInfo.recordData.length;i++){
           if(i == this.currentIndex){
             this.recordInfo.recordData[i].drug_id  = val.id
             this.recordInfo.recordData[i].drug_name = val.drug_name
             this.recordInfo.recordData[i].drug_type = val.drug_type
             this.recordInfo.recordData[i].name  = val.dose +val.dose_unit+"*"+val.min_number+ val.min_unit+"/"+val.max_unit
             this.recordInfo.recordData[i].last_price = val.last_price
             this.recordInfo.recordData[i].price = val.last_price
             this.recordInfo.recordData[i].manufacturer =  val.manufacturer
             this.recordInfo.recordData[i].number =  val.number
             this.recordInfo.recordData[i].max_unit = val.max_unit
             this.recordInfo.recordData[i].min_unit = val.min_unit
             if(val.dealer == 0){
               this.recordInfo.recordData[i].dealer = ""
             }else{
               this.recordInfo.recordData[i].dealer = val.dealer
             }
            
           }
        }
       
      },
      getDrugBatchNumber(id){
          var params = {
            id:id
          }
        getDrugBatchNumber(params).then(response=>{
           if(response.data.state == 1){
             var list = response.data.data.list
       
             for(let i=0;i<list.length;i++){
               this.numberList.push(list[i])
             }
           }
        })
      },
      getDataConfig(module, filed_name){
       return getDataConfig(module, filed_name)
      },
    },
    created() {
      this.GetConfigInfo()
      this.propForm.goodUnit = this.$store.getters.good_unit
      const order_id = this.$route.query.id
      this.GetOrderDetail(order_id)
    }

  }
</script>

<style rel="stylesheet/css" lang="scss" scoped>
  .information {
    border: 1px #dcdfe6 solid;
    padding: 30px 20px 30px 20px;

  .border {
    border-bottom: 1px #dcdfe6 solid;
    margin: 0px 0 20px 0;
  }

  }



  .edit_separater {
    border-top: 1px solid rgb(233, 233, 233);
    margin-top: 15px;
    margin-bottom: 15px;
  }

</style>

<style>
  .sign-and-weigh-box .sign-and-weigh-box-patients .cell {
    font-size: 12px;
  }

  .sign-and-weigh-box .sign-and-weigh-box-patients .current-row > td {
    background: #6fb5fa;
  }

</style>
